unit ExPageControl;
// (c)2006 by Paul TOTH <tothpaul@free.fr>
// http://tothpaul.free.fr

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
 Windows,Messages,Controls,ComCtrls,CommCtrl,SysUtils,Graphics;

type
 TPageControl=class(ComCtrls.TPageControl)
 private
  procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
 protected
  procedure CreateParams(var Params: TCreateParams); override;
 end;

implementation

procedure TPageControl.CreateParams(var Params: TCreateParams);
begin
 inherited;
 Params.Style:=Params.Style or TCS_OWNERDRAWFIXED;
end;

procedure TPageControl.CNDrawItem(var Message: TWMDrawItem);
var
 SaveIndex: Integer;
 Caption:string;
 Size   :TSize;
 x,y    :integer;
begin
  with Message.DrawItemStruct^ do
  begin
    SaveIndex := SaveDC(hDC);
    Canvas.Lock;
    try
      Canvas.Handle:=hDC;
      Canvas.Font  :=Font;
      Canvas.Brush :=Brush;
      //DrawTab(itemID, rcItem, itemState and ODS_SELECTED <> 0);
      Caption:=Self.Tabs.Strings[ItemID];
      Size:=Canvas.TextExtent(Caption);
      x:=rcItem.Left+(rcItem.Right-rcItem.Left-Size.cx) div 2;
      y:=rcItem.Top +(rcItem.Bottom-rcItem.Top-Size.cy) div 2+1;
      if itemState and ODS_SELECTED<>0 then dec(y);
      Canvas.TextRect(rcItem,x,y,Caption);
    finally
      Canvas.Handle := 0;
      Canvas.Unlock;
      RestoreDC(hDC, SaveIndex);
    end;
  end;
  Message.Result := 1;
end;

end.

