unit TrayIcons;

// (c)2006 by Paul TOTH <tothpaul@free.fr>
// http://tothpaul.free.fr

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

// based on happyjoe
// http://www.swissdelphicenter.ch/en/showcode.php?id=1164

//http://www.swissdelphicenter.ch/torry/showcode.php?id=1587

interface

uses
 Windows, Messages, Classes, SysUtils, ShellAPI, Dialogs;

const
 NIF_INFO=$10;
 NIIF_INFO =1;

 NIM_SETVERSION = $00000004;

 NIN_BALLOONUSERCLICK = WM_USER + 5;

type
 TNotifyIconData5 = Record
  cbSize: DWORD;
  Wnd: HWND;
  uID: UINT;
  uFlags: UINT;
  uCallbackMessage: UINT;
  hIcon: HICON;
 //Version 5.0
  szTip: array [0..127] of Char;
  dwState: DWORD;
  dwStateMask: DWORD;
  szInfo: array [0..255] of Char;
  uTimeout:UINT; // or uVersion
  szInfoTitle: array [0..63] Of Char;
  dwInfoFlags: DWORD;
 end;

 PNotifyIconData5 = ^TNotifyIconData5;

procedure AddSysTray(var NID:TNotifyIconData5; Method:TWndMethod);
procedure DelSysTray(const NID:TNotifyIconData5);
procedure TrayInfo(NID:TNotifyIconData5; const Info:string);

function WindowList(Thread:THandle):string;

function IsToolTipsClick(Thread:THandle):boolean;

implementation

function GetRect(HWnd:integer):string;
var
 r:TRect;
begin
 GetWindowRect(HWnd,r);
 Result:=Format('(%d,%d,%d,%d)',[r.Left,r.Top,r.Right,r.Bottom]);
end;

function EnumChilds(HWnd:integer; List:TStringList):bool; stdcall;
var
 Caption:array[0..80] of char;
 Str:string;
begin
 GetWindowText(HWnd,Caption,SizeOf(Caption));
 Str:=Caption;
 GetClassName(HWnd,Caption,SizeOf(Caption));
 Str:=Str+' ['+Caption+']';
 List.Add('>'+Str+GetRect(HWnd));
// EnumChildWindows(HWnd,@EnumChilds,integer(List));
 Result:=True;
end;

function EnumWindows(HWnd:integer; List:TStringList):bool; stdcall;
var
 Caption:array[0..80] of char;
 Str:string;
begin
 GetWindowText(HWnd,Caption,SizeOf(Caption));
 Str:=Caption;
 GetClassName(HWnd,Caption,SizeOf(Caption));
 Str:=Str+' ['+Caption+']'+GetRect(HWnd);
 List.Add(Str);
 EnumChildWindows(HWnd,@EnumChilds,integer(List));
 Result:=True;
end;

function WindowList(Thread:THandle):string;
var
 List:TStringList;
begin
 List:=TStringList.Create;
 try
  EnumThreadWindows(Thread,@EnumWindows,integer(List));
  Result:=List.Text;
 finally
  List.Free;
 end;
end;

type
 TToolTypeClick=record
  Cursor:TPoint;
  Rect  :TRect;
  HWnd  :integer;
 end;

function EnumToolTipsWindows(HWnd:integer; var TTC:TToolTypeClick):bool; stdcall;
var
 ClassName:array[0..80] of char;
begin
 GetWindowRect(HWnd,TTC.Rect);
 if (TTC.Cursor.x>=TTC.Rect.Left)
 and(TTC.Cursor.x<=TTC.Rect.Right)
 and(TTC.Cursor.y>=TTC.Rect.Top)
 and(TTC.Cursor.y<=TTC.Rect.Bottom) then begin
  GetClassName(HWnd,ClassName,SizeOf(ClassName));
  if string(ClassName)='tooltips_class32' then begin
   TTC.HWnd:=HWnd;
   Result:=False;
   exit;
  end;
 end;
 Result:=True;
end;

function IsToolTipsClick(Thread:THandle):boolean;
var
 ttc:TToolTypeClick;
begin
 GetCursorPos(ttc.Cursor);
 ttc.HWnd:=0;
 EnumThreadWindows(Thread,@EnumToolTipsWindows,integer(@ttc));
 Result:=ttc.HWnd<>0;
end;

procedure AddSysTray(var NID:TNotifyIconData5; Method:TWndMethod);
begin
 NID.Wnd:=AllocateHWnd(Method);
 NID.uCallbackMessage:=WM_USER;
 NID.uTimeout:=3; // VERSION
 Shell_NotifyIcon(NIM_ADD,@NID);
end;

procedure DelSysTray(const NID:TNotifyIconData5);
begin
 Shell_NotifyIcon(NIM_DELETE,@NID);
 DeallocateHWnd(NID.Wnd);
end;

procedure TrayInfo(NID:TNotifyIconData5; const Info:string);
begin
 NID.uFlags:=NIF_INFO;
 StrPLCopy(NID.szInfo,Info,SizeOf(NID.szInfo)-1);
 NID.uTimeout:=2000;
 NID.szInfoTitle:='SIPInside';
 NID.dwInfoFlags:=NIIF_INFO;
 Shell_NotifyIcon(NIM_MODIFY,@NID);
end;

end.

